package com.utopiaindustries.qualitycontrol.activities;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.activity.EdgeToEdge;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.graphics.Insets;
import androidx.core.view.ViewCompat;
import androidx.core.view.WindowInsetsCompat;

import com.utopiaindustries.qualitycontrol.R;
import com.utopiaindustries.qualitycontrol.helper.Helper;
import com.utopiaindustries.qualitycontrol.helper.Preference;
import com.utopiaindustries.qualitycontrol.models.QualitySaveResponse;

public class SummaryActivity extends AppCompatActivity {

    TextView txtPercentage, txtCutting, txtStitching, txtChecking, txtPacking, txtSubStore, txtReportId;
    String overallPercentage;
    ImageView img_back;
    QualitySaveResponse qualitySaveResponse;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        EdgeToEdge.enable(this);
        setContentView(R.layout.activity_summary);
        ViewCompat.setOnApplyWindowInsetsListener(findViewById(R.id.main), (v, insets) -> {
            Insets systemBars = insets.getInsets(WindowInsetsCompat.Type.systemBars());
            v.setPadding(systemBars.left, systemBars.top, systemBars.right, systemBars.bottom);
            return insets;
        });

        initialization();

        txtPercentage.setText(String.format("%s %%", overallPercentage));
        txtCutting.setText(String.format("%s %%", qualitySaveResponse.getCutting()));
        txtStitching.setText(String.format("%s %%", qualitySaveResponse.getStiching()));
        txtChecking.setText(String.format("%s %%", qualitySaveResponse.getChecking()));
        txtPacking.setText(String.format("%s %%", qualitySaveResponse.getPacking()));
        txtSubStore.setText(String.format("%s %%", qualitySaveResponse.getSub_Store()));
        txtReportId.setText(String.format("Code: %s", qualitySaveResponse.getReportId()));

        img_back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                clearPreferences();

                finish();
                Intent intent = new Intent(SummaryActivity.this, HomeActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
                intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);
            }
        });

    }

    public void initialization() {
        qualitySaveResponse = (QualitySaveResponse) getIntent().getSerializableExtra("Summary");
        overallPercentage = getIntent().getStringExtra("Percentage");

        /*Log.e("Cutting: ",""+qualitySaveResponse.getCutting());
        Log.e("Stitching: ",""+qualitySaveResponse.getStiching());
        Log.e("Checking: ",""+qualitySaveResponse.getChecking());
        Log.e("Packing: ",""+qualitySaveResponse.getPacking());
        Log.e("Substore: ",""+qualitySaveResponse.getSub_Store());
        Log.e("Overall: ",""+qualitySaveResponse.getOverAllPercentage());*/

        img_back = findViewById(R.id.img_back);
        txtPercentage = findViewById(R.id.txt_percentage);
        txtCutting =  findViewById(R.id.txt_cutting_percentage);
        txtStitching = findViewById(R.id.txt_stitching_percentage);
        txtChecking = findViewById(R.id.txt_checking_percentage);
        txtPacking = findViewById(R.id.txt_packing_percentage);
        txtSubStore = findViewById(R.id.txt_substore_percentage);
        txtReportId = findViewById(R.id.txt_report_id);
    }

    public void clearPreferences() {
        try {
            Preference.remove(Helper.project_file, Helper.departmentId, SummaryActivity.this);
            Preference.remove(Helper.project_file, Helper.departmentName, SummaryActivity.this);

            Preference.remove(Helper.project_file, Helper.locationSiteId, SummaryActivity.this);
            Preference.remove(Helper.project_file, Helper.locationSiteName, SummaryActivity.this);

            Preference.remove(Helper.project_file, Helper.unitId, SummaryActivity.this);
            Preference.remove(Helper.project_file, Helper.unitName, SummaryActivity.this);

            Preference.remove(Helper.project_file, Helper.floorId, SummaryActivity.this);
            Preference.remove(Helper.project_file, Helper.floorName, SummaryActivity.this);

            Helper.RemoveArrayList(Helper.listCutting, SummaryActivity.this);
            Helper.RemoveArrayList(Helper.listStitching, SummaryActivity.this);
            Helper.RemoveArrayList(Helper.listChecking, SummaryActivity.this);
            Helper.RemoveArrayList(Helper.listPacking, SummaryActivity.this);
            Helper.RemoveArrayList(Helper.listSubStore, SummaryActivity.this);
        }
        catch (Exception ex) {
            Log.e("Exception: ",""+ ex.getMessage());
        }
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();
        clearPreferences();
        finish();
        Intent intent = new Intent(SummaryActivity.this, HomeActivity.class);
        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_NEW_TASK);
        intent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TASK | Intent.FLAG_ACTIVITY_NEW_TASK);
        startActivity(intent);
    }
}