package com.utopiaindustries.qualitycontrol.adapters;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.utopiaindustries.qualitycontrol.R;
import com.utopiaindustries.qualitycontrol.models.LocationSite;

import java.util.List;

public class ScoreSpinnerAdapter extends ArrayAdapter<String> {

    private final Context context;
    private final List<String> items;

    public ScoreSpinnerAdapter(Context context, List<String> items) {
        super(context, 0, items);
        this.context = context;
        this.items = items;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        if (convertView == null) {
            convertView = LayoutInflater.from(context).inflate(R.layout.list_items, parent, false);
        }

        String item = items.get(position);

        TextView titleTextView = convertView.findViewById(R.id.item_text);

        titleTextView.setText(item);

        return convertView;
    }
}
